import {Worker} from 'node:worker_threads';





function runWorkerThread(workerData) {
    return new Promise((resolve, reject) => {
        const worker = new Worker('./worker.js', {workerData});

        worker.on('message', resolve);
        worker.on('error', reject);
        worker.on('exit', (code) => {
            if (code !== 0)
                reject(new Error(`Worker stopped with exit code ${code}`));
        });
    });
}

export async function runConcurrentTasks() {
    const tasks = ['Task 1', 'Task 2', 'Task 3'];
    const results = await Promise.all(tasks.map(task => runWorkerThread(task)));
    console.log(results);
}


